#!/usr/bin/python # python 2.7
# Auxiliary python program for the runTrains.py that takes train/edges/paths and runs trains.
# Sudhanshu Shekhar Jha wrote in Feb 2018. From scratch. 
# Deepak Miglani's used hindrance matrix but didn't build occupancy lists. 
# Deepak's was a python implementation of Ashish Dogra's xls hindrances' matrices: Feb 2017
# Shripad/Sathishkumar's simpy implementation for CST (and Pen?) also works, input needs
# uniformizing
# Tejas Ghorpade had a simpy implementation too (but of 
# which method, Madhu forgot): about Nov 2016

def hhmm2mm(hhmm): # just hhmm as numbers, or hmm, 0 or 1 alone would mean 0000 or 0001.
    # hhm is not OK. hmm is ok.
    """Function to change time format from HHMM to MMMM"""
    if len(hhmm) == 4: 
       hh = hhmm[0:2]
       mm = hhmm[2:]
    elif len(hhmm) == 3: 
       hh = str(0)+hhmm[0]
       mm = hhmm[1:]
    elif len(hhmm) == 2: 
       hh = str(0)+str(0) # to get string '00', you cannot use str(00), since number 00 is 0
       mm = hhmm
    else:
       hh = '00' 
       mm = str(0)+hhmm # hopefully 1 
    return 60*int(hh)+int(mm)
    # print '76', hhmm2mm('76') # print '056', hhmm2mm('056')
    # print '0056', hhmm2mm('0056') # print '1056', hhmm2mm('1056')
    # print '2400', hhmm2mm('2400') # print '2301', hhmm2mm('2301')
    # print '2359', hhmm2mm('2359')

def m2hm(mmmm): # at most 1440 minutes per day. # todo: mmmm is negative for  very small
     # values of train arrival time. TODO todo
    """Function to change time format from mins to HHMM"""
    mmmm=int(mmmm)
    hrs=int(int(mmmm)/60)
    minutes = mmmm-hrs*60
    if hrs < 10: hh = str(0)+str(hrs)
    else: hh = str(hrs)
    if minutes < 10: mm = str(0)+str(minutes)
    else: mm = str(minutes)
    # if mmmm > 1440: print("Problem: time more than one day!",mmmm)
    # print mmmm, hh, mm
    try:
       return hh+mm
    except ValueError:
       print("Error3: mmmm, hrs, hh, minutes, mm", mmmm, hrs, hh, minutes, mm)
       return hh+mm
    # print 1440, m2hm(1440) # print 506, m2hm(506)
    # print 6, m2hm(6) # print 70, m2hm(70)
    # print 69, m2hm(69) # print 0, m2hm(0)

def l2m(edgeLength,speed,trainLength): # length to minutes: was diff_timeP first
    """code that returns time (in minutes) on edges and platform, with input-length in metres and input-speed in kmph"""
    # flagPE : platform=1 or edge=0, # flagFB: forward=0 or backward=1
    edgeLength=float(edgeLength) # in metres
    # clearanceA= float(clearanceA) # in metres
    # clearanceS= float(clearanceS) # in metres
    trainLength=float(trainLength) # in metres
    speed=1000.0*float(speed)/60.0 # In RHS speed in kmph, and in LHS in metres/minute
    minutes=(edgeLength+trainLength)/speed 
    # return 10
    return minutes


def getEdge(edgeName, edgeList, nodeList): 
  try: return edgeList[edgeName] 
  except KeyError:
    return getSpecialNode(edgeName, nodeList) 

def isPathEdgeLine(edgeName, edgeList):
   try: return edgeList[edgeName].isLine
   except KeyError: return False

def returnPathEdgeLineNum(edgeName, edgeList):
   try: 
     return edgeList[edgeName].lineNum
   except IndexError: 
     print("Error3: inside returnPathEdgeLineNum:", edgeName)
     return edge[0].lineNum

def getSpecialNode(edgeName, nodeList):
   node = [n for n in nodeList if n.name == edgeName] 
   # print ""
   try:
      return nodeList[node[0].num]
   except IndexError:
      print("Error5: Looking for Special Node/Edge: edgeName", edgeName) # , len(nodeList)
      return nodeList[node[0].num]

def maxSpeed(edgeNamesList, edgeList, nodeList):
  """Takes a list of edges and returns the minimum speed
  amongst all the edges' max-speeds from this edge (and node) list
  Unit remains same (most likely kmph)"""
  # global edgeList
  maxSp = 100 # kmph (sufficiently high, hopefully will come down)
  # print "Checking7", edgeNamesList
  for eName in edgeNamesList:
    edgObj = getEdge(eName, edgeList, nodeList)
    maxSp = min(float(edgObj.speed),maxSp) # Madhu  # Madhu 
  return maxSp


"""
full path min speed to begin with : for through trains
full path availability (upto exit) checked before entry allowed into junction area
Speed on each edge: minimum of entry-platform, or platform to exit, or full path (depending on through or not)
   Check maxSpeed for FULL path for through trains
priority wise scheduling
line/platform check
hhmm to mm to hhmm check
clog network and check if getting no path found: overcongested/jammed)
"""


