#!/bin/bash
# script to be used for extracting Ahmedabad junction infrasructure from
# the google spreadsheet prepared in May 2019 by Vipin/Shripad/Sudarshan/Shobhna-Misra/Madhu
# Extraction into separate csv files from just 
# one google-spreadsheet: prepared by Pratibha M. Varadkar (PCLAB RA)

halfPathTempFile=halfPathsTemp.csv
halfPathFileP1P2=halfPathsP1P2.csv
halfPathFileNone=halfPathsNone.csv
halfPathFileP1only=halfPathsP1on.csv
halfPathFileP2only=halfPathsP2on.csv
trainFile=traADIgdrive.csv
nodeFile=nodeDeg4plus.csv
lineFile=lineEdgeNames.csv
edgeFile=edgeADIgdrive.csv
souDFile=sourceDesNS.csv

temp1=temp1.csv
temp2=temp2.csv

wget --output-document=$halfPathTempFile "https://docs.google.com/spreadsheets/u/0/d/1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE/export?format=csv&id=1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE&gid=1002433918"


cat $halfPathTempFile > $halfPathFileP1P2 # BOTH P1 AND P2


grep -v -e '^P1' -e '^P2' $halfPathTempFile > $halfPathFileNone # Neither P1 NOR P2
grep -v -e '^P2' $halfPathTempFile > $halfPathFileP1only
grep -v -e '^P1' $halfPathTempFile > $halfPathFileP2only

wget --output-document=$nodeFile "https://docs.google.com/spreadsheets/u/0/d/1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE/export?format=csv&id=1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE&gid=1581279663"

wget --output-document=$lineFile "https://docs.google.com/spreadsheets/u/0/d/1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE/export?format=csv&id=1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE&gid=1924796992"

wget --output-document=$temp1 "https://docs.google.com/spreadsheets/u/0/d/1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE/export?format=csv&id=1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE&gid=1095146152"
grep -e '^ConsiderTF' -e '^TRU' $temp1 | cut -d"," -f2- > $trainFile # to get rid of TRUE/FALSE (same as z, but quicker editing in google-spreadsheet)

wget --output-document=$edgeFile "https://docs.google.com/spreadsheets/u/0/d/1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE/export?format=csv&id=1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE&gid=44524211"

wget --output-document=$souDFile "https://docs.google.com/spreadsheets/u/0/d/1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE/export?format=csv&id=1HC5enSqe3snqLEIHIIlHhrpstznRBTGYZ0pkhJDh7NE&gid=81227108"

exit

# wget --output-document=$Fine2Coarse "https://docs.google.com/spreadsheets/u/0/d/
1wEHFEVKjm4zVK-BoXQOuIKaqX55SHZYtvveIPwkJflU/export?format=csv&id=
1wEHFEVKjm4zVK-BoXQOuIKaqX55SHZYtvveIPwkJflU&gid=116733915"
# wget --output-document=$fac2AreaFile "https://docs.google.com/spreadsheets/u/0/d/1wEHFEVKjm4zVK-BoXQOuIKaqX55SHZYtvveIPwkJflU/export?format=csv&id=1wEHFEVKjm4zVK-BoXQOuIKaqX55SHZYtvveIPwkJflU&gid=0"

wget --output-document=$comm2fac "https://docs.google.com/spreadsheets/u/0/d/1wEHFEVKjm4zVK-BoXQOuIKaqX55SHZYtvveIPwkJflU/export?format=csv&id=1wEHFEVKjm4zVK-BoXQOuIKaqX55SHZYtvveIPwkJflU&gid=817280169"

wget --output-document=$DisAllow "https://docs.google.com/spreadsheets/u/0/d/1wEHFEVKjm4zVK-BoXQOuIKaqX55SHZYtvveIPwkJflU/export?format=csv&id=1wEHFEVKjm4zVK-BoXQOuIKaqX55SHZYtvveIPwkJflU&gid=1960328565"

wget --output-document=$DisCourage "https://docs.google.com/spreadsheets/u/0/d/1wEHFEVKjm4zVK-BoXQOuIKaqX55SHZYtvveIPwkJflU/export?format=csv&id=1wEHFEVKjm4zVK-BoXQOuIKaqX55SHZYtvveIPwkJflU&gid=1122291243"

cut -d";" -f2- $fac2AreaFile > $temp
cut -d"," -f2- $temp | grep -i '[a-z]' > $fac2AreaFile

cut -d";" -f2- $Fine2Coarse > $tempFile
cut -d"," -f2- $tempFile | grep -i '[a-z]' > $Fine2Coarse

cut -d";" -f2- $comm2fac > $tempFile
cut -d"," -f2- $tempFile | grep -i '[a-z]' > $comm2fac

cut -d";" -f2- $DisAllow > $tempFile
cut -d"," -f2- $tempFile | grep -i '[a-z]' > $DisAllow

cut -d";" -f2- $DisCourage > $tempFile
cut -d"," -f2- $tempFile | grep -i '[a-z]' > $DisCourage





