#!/usr/bin/python3 
# python 3 from 2nd July 2019
# OLD: !/usr/bin/python # python 2.7
# https://drive.google.com/open?id=14Y_hvqUf4pO6-qo3_X0Kw3PnPUifFtYz
# Python program that takes train/edges/paths and runs trains.
# Sudhanshu Shekhar Jha wrote in Feb 2018. From scratch. 
# Deepak Miglani's used hindrance matrix but didn't build occupancy lists. 
# Deepak's was a python implementation of Ashish Dogra's xls hindrances' matrices: Feb 2017
# Shripad/Sathishkumar's simpy implementation for CST (and Pen?) also works, input needs
# uniformizing
# Tejas Ghorpade had a simpy implementation too (but of 
# which method, Madhu forgot): about Nov 2016

printOccupancyLists = True
PathViewCheck = False
toVisualize = False
analyzeCongestion = False
checkPathLengths = False
isSignalOverlap = False
findFrCapacity = True

global thresholdMinsLine, thresholdMinsPath # threshold
thresholdMinsLine = 500 # used for gotWithinThrsld about how many minutes to wait before trying another platform/line
thresholdMinsPath = 480 # used for gotWithinThrsld about how many minutes to wait before trying another path
# TOO many paths for almost any given LINE.
# We expect that we can fore-go path after LESSER wait than LINE/PLATFORM. So : thresholdMinsPath < thresholdMinsLine  

fineness = 1 # minutes # how fine a time to keep checking if resource is free 
edgeStopMovement = 0 # minutes # after how much time an edge can be used after a train has departed

# todo: make max speed come from half-paths
# todo: each halfpath gets net-distance (including platform) too (just after half-path instantiation)
# todo: each train's allpaths (list of lists): add length of path
# todo: LATER Pick path from allpaths list which has earliest exit-from-junction area
# todo: train.allpaths has some "corresponding" lists (same length, indices linked.)
# todo: Shift preferred platform delimiter to :
# anything after semicolon to be ignored
# Resolve line number and platform number column unamiguously. Using 1.5 as line number not ok.
# TODO: Line/Platform (for edges at the "CENTER" of the path?)
# TODO: Check line/platform PREFERENCE
# TODO: shunting movements
# TODO: one reversal 
# TODO: put check if path found at all (with "no path found: overcongested/jammed)
# TODO: read edge "pre-occupancies" from a file, and write new occupancies into that same-format file
# TODO: can be used for maintenance block of certain edges (or platforms)


import pandas as pd
import numpy as np
from auxiFunctions import *
from collections import OrderedDict
import copy
import matplotlib.pyplot as plt
from sys import argv

# Manually ensure:
# edge numbers should be index in eLst
# edge.csv file will be assumed sorted according to serial 
# number column (first column), and Sr.num starts from 0. If not we will sort later.

# input files: speeds in kmph (edge/node max speed, and train max speed)
# input files: lengths in m (edge length, and train length, and clearances)


# cannot change column indices
edgeFile='inFiles/edgeADIgdrive.csv' # Ahmedabad # gdrive CANNOT change column indices
nodeFile='inFiles/nodeDeg4plus.csv' # degree 4+ only  # gdrive CANNOT change column indices

# can change column indices
halfPathFile='inFiles/'+argv[1]  # Ahmedabad # gdrive
trainFile='inFiles/traADIgdrive.csv'   # Ahmedabad # gdrive
lineFile='inFiles/lineEdgeNames.csv'   # Ahmedabad # gdrive
sourDesFile='inFiles/sourceDesNS.csv' # This has sources/destination nodes labelled as north/south side
# edgeOccupancyFile='inFiles/edgeOccupanciesADI.csv' # Ahmedabad # yet 2 shift
preOccupEdgeFile='inFiles/edgePreOccupancies.csv'

nf = pd.read_csv(nodeFile, header = None, delimiter=',', engine='python')
efN = pd.read_csv(edgeFile, keep_default_na=False)# reading edges in header-name style
hpf = pd.read_csv(halfPathFile, keep_default_na=False) # reading half-path in header-name style
lineF = pd.read_csv(lineFile, keep_default_na=False) 
tf = pd.read_csv(trainFile, keep_default_na=False) 
soDesFr = pd.read_csv(sourDesFile, keep_default_na=False) 
# edOcFr =  pd.read_csv(edgeOccupancyFile, keep_default_na=False) # Edge Occupancies (for maintenance)

preOccEdgFr = pd.read_csv(preOccupEdgeFile, keep_default_na=False) # Edge Occupancies (for maintenance)
preOccSrNum =  preOccEdgFr['SrNum'].values.tolist(); preOccEdName =  preOccEdgFr['EdgeName'].values.tolist();
preOccReaso =  preOccEdgFr['Occupant'].values.tolist(); preOccStartMM =  preOccEdgFr['StartMM'].values.tolist();
preOccEndMM =  preOccEdgFr['EndMM'].values.tolist();


tfSrN=tf['SrNum'].values.tolist(); tfNum=tf['TrainNum'].values.tolist(); tfNam=tf['TrainName'].values.tolist();
tfSou=tf['Source'].values.tolist(); tfDes=tf['Destin'].values.tolist(); tfPri=tf['Priority'].values.tolist();
# tfHal=tf['Halt'].values.tolist(); 
tfArr=tf['ArrHHMM'].values.tolist(); tfDep=tf['DepHHMM'].values.tolist()
tfPreLin=tf['PrefLineListSemicolons'].values.tolist(); tfForbid=tf['forbiddenPFs'].values.tolist()
# tfDaily=tf['Daily-day-of-week'].values.tolist(); 
tfMaxSp=tf['MaxSpeed-kmph'].values.tolist();
tfLengM=tf['Length-meters'].values.tolist(); # tfAcc=tf['Acceleration'].values.tolist();
# tfDec=tf['Deceleration'].values.tolist(); 
# tfTraOcc=tf['TrainOccupyEdgeTime'].values.tolist();
tfPassYN=tf['isPassenger'].values.tolist(); tfLocoPlan=tf['LocoPlan'].values.tolist();

hpfHemnt=hpf['Hemant-ADI-input'].values.tolist(); hpfNoSuPart=hpf['NoSuhPart'].values.tolist()
hpfPathName=hpf['PathName'].values.tolist(); hpfSouOrLine=hpf['SouOrLine'].values.tolist()
hpfLineOrDes=hpf['LineOrDes'].values.tolist(); hpfLineName=hpf['LineName'].values.tolist()
hpfMaxSpd=hpf['MaxSpeed-kmph'].values.tolist() ; hpfEdges=hpf.loc[:,'edge0':'edge32'].values.tolist()

efName =  efN['EdgeName'].values.tolist(); efLength =  efN['Length-m'].values.tolist() 
efMaxSpeed = efN['EdgeMaxSpeed-kmph'].values.tolist();

norEnds = soDesFr['North-side-SoDe'].values.tolist(); souEnds = soDesFr['South-side-SoDe'].values.tolist();

class HalfPath:
  def __init__(self,halfName,source,destin,lineName,maxSpeed,edges): 
     self.halfName=halfName; self.source=source; self.destin=destin; self.lineName=lineName;
     self.maxSpeed=maxSpeed; self.edges=edges; self.maxSpeed=maxSpeed; self.edges=edges;
     self.platform=False
     self.isSouth= False # isSouth = True means south of line
     self.isNorth= False # isSouth = True means south of line

  def setPlatform(self):
     global nLst, eLst, halfPathLst
     if self.lineName == 'Dummy':
        print('--its dummy--')
        for i in self.edges:
           if getEdge(i,eLst,nLst) in nLst: continue
           elif getEdge(i,eLst,nLst).isLine:
              self.lineName=i
        if self.lineName == 'Dummy':
           halfPathLst.remove(self)
         #   print("Dummy Detected and removed halfPath")
           return 

     try:
        lineEdge = getEdge(self.lineName,eLst,nLst) 
        if lineEdge.isLine: self.platform = lineEdge.lineNum
     except:
        print(self.halfName,self.source,self.destin,self.edges)
        exit()
  def hpLength(self,takePlatform=True): #added by sudarshan
       hpLen = 0.0
       for i in self.edges:
          if i == self.platform and not takePlatform: continue
          hpLen += getEdge(i,eLst,nLst).length
       return hpLen

halfPathLst = []
for i in range(len(hpfPathName)): # Halfpath instantiation with north/south appending into name
  if hpfPathName[i].startswith('z'): pass # print "Due to z-starting, ignoring half-path", hpfPathName[i]
  else:
     halfPathName=hpfNoSuPart[i]+hpfPathName[i]
     temp = HalfPath(halfPathName, hpfSouOrLine[i], hpfLineOrDes[i], hpfLineName[i], hpfMaxSpd[i], list(filter(lambda a: a != '', hpfEdges[i])))
     if hpfNoSuPart[i] == 'SouthPart': temp.isSouth=True
     if hpfNoSuPart[i] == 'NorthPart': temp.isNorth=True
     halfPathLst.append(temp)

def updateFrom2Where(tr,hPathCounts): 
  """gets the train and the corresponding half-path counts.
  Ideally only 2 out of the 4 should be nonzero. That is also flagged here.""" 
  isSourS = hPathCounts[0]>0
  isDestS = hPathCounts[1]>0
  isSourN = hPathCounts[2]>0
  isDestN = hPathCounts[3]>0
  if isSourS and isDestS: tr.direction = 'South2South'
  if isSourN and isDestS: tr.direction = 'North2South'
  if isSourS and isDestN: tr.direction = 'South2North'
  if isSourN and isDestN: tr.direction = 'North2North'
  print("From2Where updated for train: ", tr.numb, tr.direction, tr.source, tr.destin)

def getAllPathsFromHalfPaths(tr):
    global halfPathLst
    pathcount=0
    trHPaths = []
    # print tr.numb, tr.source, tr.destin, tr.prefPlatforms, tr.prefEdges
    for hp in halfPathLst: # first just search through ALL half-paths for any vague match between hp/tr's : platform/source/destination
       if hp.platform in tr.prefPlatforms:
          if tr.source in [hp.source, hp.destin] or tr.destin in [hp.source, hp.destin]:
             trHPaths.append(hp)
    if len(trHPaths) > 0:
       for ed in tr.prefEdges:
          trShpS = [hp for hp in trHPaths if tr.source == hp.source and hp.lineName == ed] # no reversal of of hp 
          trDhpS = [hp for hp in trHPaths if tr.destin == hp.source and hp.lineName == ed] # reversal of hp
          trShpD = [hp for hp in trHPaths if tr.source == hp.destin and hp.lineName == ed] # reversal of hp
          trDhpD = [hp for hp in trHPaths if tr.destin == hp.destin and hp.lineName == ed] # no reversal of of hp
          updateFrom2Where(tr, [len(trShpS), len(trDhpS), len(trShpD), len(trDhpD)])
         #  print("HPdebug", len(trShpS), len(trDhpS), len(trShpD), len(trDhpD), ed) # ideally, exactly 2/4 should be zero 
          # for hpaths: source on south side, and destination on north side (north-part or south part)
          # for hp in trHPaths: # all hpaths with platformS relevant, and SOME s/d matching
          # straight (no-reversal) means True, reverse means False
          # print tr.source, filter(lambda a: a != '', souEnds), tr.destin, filter(lambda a: a != '', norEnds)
          if tr.source in souEnds and tr.destin in norEnds: # reverse nothing: trShpS and trDhpD
              allPaths,maxspeeds,allLengths = appendHPaths(trShpS,trDhpD,True,True) 
              print("allpaths = appendHPaths(trShpS,trDhpD,True,True)", len(allPaths) )
          if tr.source in souEnds and tr.destin in souEnds: # reverse second part (exit side): trShpS and trDhpS
              allPaths,maxspeeds,allLengths = appendHPaths(trShpS,trDhpS,True,False) 
              print("allPaths = appendHPaths(trShpS,trDhpS,True,False)", len(allPaths) )
          if tr.source in norEnds and tr.destin in norEnds: # reverse entry part (first part) only: trShpD and trDhpD
              allPaths,maxspeeds,allLengths = appendHPaths(trShpD,trDhpD,False,True) 
              print("allPaths = appendHPaths(trShpD,trDhpD,False,True)", len(allPaths))
          if tr.source in norEnds and tr.destin in souEnds: # reverse both: use trShpD and trDhpS
              allPaths,maxspeeds,allLengths = appendHPaths(trShpD,trDhpS,False,False) 
              print("allPaths = appendHPaths(trShpD,trDhpS,False,False)", len(allPaths))
           # Reversal logic to be put for source in north part only.
          try:
             tr.allpaths.extend(allPaths)
             tr.allpathsMaxSpeeds.extend(maxspeeds)
             tr.allpathsLengthTups.extend(allLengths)
          except UnboundLocalError: 
             print('ERROR:',tr.numb,'source and destin dont match')
             
    if len(tr.allpaths) == 0: print("Error01: Found no paths:", tr.numb, tr.source, tr.destin, tr.prefPlatforms, tr.prefEdges, len(trHPaths))
    else: #print("Found path(s) for train", tr.numb, len(tr.allpaths),len(tr.allpathsMaxSpeeds), len(tr.allpathsLengthTups), len(trHPaths))# , tr.allpaths[0]
       pass
def appendHPaths(hpL1,hpL2,retain1,retain2):
  """Receives two lists of halfpath objects and returns their edges 
        without/with reversal (respectively True/False), and also halfPaths"""
  listOfLists = []
  maxSpeedListTup = []
  rankingOfPathsTup = []
  lengthTup = [] # added by sudarshan
  for hp1 in hpL1:
    for hp2 in hpL2:
      exitSide = toRetainOrReverse(hp2.edges,retain2)
      listOfLists.append(toRetainOrReverse(hp1.edges,retain1) + exitSide[1:])
      maxSpeedListTup.append((hp1.maxSpeed,hp2.maxSpeed))
      lengthTup.append((int(hp1.hpLength()),int(hp2.hpLength(False))))
      # lengthTup.append((hp1.length,hp2.length)) # add length of platform into the first halfpath lenght
      # rankingOfPathsTup.append((hp1.grade,hp2.grade)) 
      # TODO: Sudarshan To use ABCD with reversal info perhaps.
  return listOfLists, maxSpeedListTup, lengthTup

def toRetainOrReverse(edgeLstIn,retain):
  if retain: return edgeLstIn
  else: return edgeLstIn[::-1]

# classes: Train, Edge, Node, Path
class Train: # = Train
  def __init__(self,numb,source,destin,arrhhmm,dephhmm,
               trainLength,priority,prefPlatforms,maxSpeed,isPassenger,locoPlan):
    self.numb = numb ; self.source=source;
    self.destin=destin; self.arrhhmm=arrhhmm; self.dephhmm=dephhmm;
    self.trainLength=trainLength; self.priority=priority;
    if isinstance(prefPlatforms,str):
       self.prefPlatforms=str(prefPlatforms).split(";") # comes semicolon separated as a list?
    elif isinstance(prefPlatforms,list):
       self.prefPlatforms=prefPlatforms 
    self.maxSpeed=float(maxSpeed);
    self.isPassenger=isPassenger # input trains file gives True for Passenger, and False for Freight
    self.locoPlan=locoPlan # What terminal movements are expected
    self.direction='From2Where' # North2South or South2South etc (for signal overlap)
    self.trainOccupied = False
    self.prefEdges=[]
    
    for pl in self.prefPlatforms:
      self.prefEdges.append(lineNameEdge[pl].name)
    
    self.pathFree=[]
    self.allpaths=[] # all paths from half paths file of Vipin style, list of edge-lists
    self.plIndx=[] # the platform is on which index in a specific path (first path, first entry in plIndx
    self.selectedLine=(); self.arrmm= hhmm2mm(str(self.arrhhmm)); self.depmm=hhmm2mm(str(self.dephhmm))
    self.selectedPath=None; self.entryInJunctionArea=int(); self.exitFromJunctionArea=int()
    self.entryInJunctionAreaList=[]; self.exitFromJunctionAreaList=[]
    self.costPath=[]  # measures kind of delay through each path. Will send train along path with least cost. (Minimum = 0)
    self.actArrTime=int(); self.actDepTime=int()
    self.actArrTimeList=[]; self.actDepTimeList=[]
    # self.isThrough = False #True if '706' in self.numb else False#not(self.isPassenger) # 
    self.isThrough = False#not(self.isPassenger) # 
    self.allpathsMaxSpeeds=[] # Length of this list is supposed to be same as length 
    # of allpaths, and is tuple: (maxHpS,maxHpD) of two halfpaths' maxspeeds
    self.allpathsLengthTups=[] # # to decide
    getAllPathsFromHalfPaths(self)


class Edge:  
  def __init__(self,num,name,length,speed):
               # clearanceN, clearanceS, isLine, lineNum):
      self.num = num; self.name = name; self.length=length # in meters
      #self.OccupyTime = int(OccupyTime) # read from 
      self.speed = speed # in kmph
      self.occupancy = [] # contains [train number, occupiedFrom, occupiedTill] # for all internal checks
      self.occupancyHHMM = [] # contains [train number, occupiedFrom, occupiedTill] # for display
      self.lineNum='to-set-yet'; self.clearanceN = False # in meters clearance hard-code todo
      self.clearanceS = False; self.isLine = False
      #print('sudarshan:',num,name)
     
  def isFree(self,startTime,endTime): #timeValuesIn minutes (00 = midnight 0000) # for edge
    # returns True or False
    foundIntermediateSlot = False
    if (len(self.occupancy)==0): return True # unoccupied yet
    elif self.occupancy[0][1] > endTime+edgeStopMovement: return True # needed slot VERRRY early
    elif startTime > self.occupancy[-1][2]+edgeStopMovement: return True # needed slot VERRY late
    else: # in between : check in loop
      for i in range(0,len(self.occupancy)-1): # for each occupancy band
        if(startTime>self.occupancy[i][2]+edgeStopMovement and endTime + edgeStopMovement<self.occupancy[i+1][1]):
            return True # intermediate free slot
            foundIntermediateSlot = True
            break # breaking from the for loop
      if foundIntermediateSlot: return True
      else: return False 

  def occupy(self,trNumb,startTime,endTime):
      global SIGNALOVERLAP
      self.occupancy.append([trNumb])
      self.occupancyHHMM.append([trNumb])
      # print "Checking4", self.name, trainNo, startTime, endTime
      for j in range(len(self.occupancy)-1,len(self.occupancy)): 
          self.occupancy[j].append(startTime)
          self.occupancyHHMM[j].append(m2hm(startTime))
          self.occupancy[j].append(endTime)
          self.occupancyHHMM[j].append(m2hm(endTime))
      self.occupancy.sort(key=lambda x: x[2]) 
      # print "before update edge", self.name,startTime,endTime
      if isSignalOverlap:
         if self.isLine: 
            if False: #tr.direction.startswith('North'): 
               self.clearanceS.occupy(trNumb, startTime, endTime) # Madhu: Latest policy: to enable # TODO
            if False: #tr.direction.startswith('South'): 
               self.clearanceN.occupy(trNumb, startTime, endTime) # Madhu: Latest policy: to enable # TODO
         # that edge for a minute or two (with a pre-settable time)
      if toVisualize: updateEdgesOccupancy(self.name,startTime,endTime) # Sudarshan: Madhu put int
      
class Node:          
  def __init__(self,num,name,speed):
      self.num = num; self.name = name;
      self.speed = speed # in kmph
      self.occupancy = [] # contains train number, occupiedFrom, occupiedTill
      # occupiedFrom: when trainEngine enters edge
      # occupiedTill: (kind of) till trainTail enters platform/exits junction area 
      self.occupancyHHMM = [] 
      self.length = 0 # in meters nodeLength hard-code todo
     
  def isFree(self,startTime,endTime): # for node
      # returns True if edge is Free, and returns False if occupied at that time.
      foundIntermediateSlot = False
      if (len(self.occupancy)==0): return True # UNoccupied yet
      elif self.occupancy[0][1] > endTime: return True # new train arriving (and leaving?) earlier than EARLIEST occupied
      elif startTime>self.occupancy[-1][2]: return True # train needs edge much later # new train arriving after LAST occupied
      else: #  in between (after earliest, before last)
         for i in range(0,len(self.occupancy)-1): # for each occupancy band
           if(startTime>self.occupancy[i][2] and endTime<self.occupancy[i+1][1]):
             return True # intermediate free slot
         if foundIntermediateSlot: return True
         else: return False 

  def occupy(self,trNumb,startTime,endTime):
      self.occupancy.append([trNumb])
      self.occupancyHHMM.append([trNumb])
      for j in range(len(self.occupancy)-1,len(self.occupancy)):
          self.occupancy[j].append(startTime)
          self.occupancyHHMM[j].append(m2hm(startTime))
          self.occupancy[j].append(endTime)
          self.occupancyHHMM[j].append(m2hm(endTime))
      self.occupancy.sort(key=lambda x: x[2]) 


#instantiate Train class and sort in terms of priority
#numb,source,destin,arrhhmm,dephhmm,halt,
               # trainLength,priority,prefPlatforms,OccupyTime,isPassenger

_EdgeOccupancyinMin={i:[] for i in range(1441)} # Sudarshan wrote this
def updateEdgesOccupancy(EdgeName,StartTime,EndTime): # Sudarshan wrote this
   staT = int(StartTime)
   endT = int(EndTime)
   for i in range(staT, endT):
     if _EdgeOccupancyinMin.get(i)==None :_EdgeOccupancyinMin[i]=[]
     _EdgeOccupancyinMin[i].append(EdgeName)
   
# in other py file.
# hhmm2mm(hhmm) 
# m2hm(mmmm) l2m(edgeLength,speed,trainLength): # length to minutes: was diff_timeP first
# getEdge(edgeName,eLst): isPathEdgePlatform(edgeName,eLst): isPathEdgeLine(edgeName,eLst):
# returnPathEdgetempLineNum(edgeName, eLst): getSpecialNode(edgeName, nLst): maxSpeed(edgeNamesList,eLst, nLst):
NS,NSG,SN,SNG=0,0,0,0
tNS,tNSG,tSN,tSNG=('2400','2400','2400','2400')
def addFreightTrain(trn,case):
   global tNS,tNSG,tSN,tSNG,NS,NSG,SN,SNG
   #numb,source,destin,arrhhmm,dephhmm,trainLength,priority,
   # prefPlatforms,maxSpeed,isPassenger,locoPlan)
   if 'new' in trn.numb:
      '''
      if 'NS' in trn.numb:
         tNS = m2hm(trn.exitFromJunctionArea)
      elif 'NSG' in trn.numb:
         tNSG = m2hm(trn.exitFromJunctionArea)
      elif 'SN' in trn.numb:
         tSN = m2hm(trn.exitFromJunctionArea)         
      elif 'SNG' in trn.numb:
         tSNG = m2hm(trn.exitFromJunctionArea)
      '''
      tNS = str(m2hm(trn.actDepTime - 15)) if trn.trainOccupied else tNS
      tNSG = tNS
      tSN = tNS
      tSNG = tNS      

   prefPlatforms = ['L5','L6','L7','L8']
   if case == 0:
      numb = "new-NS"+str(NS+1)
      source = np.random.choice(['S85','S87'])
      destin = np.random.choice(['283-303','3042','284-307'])
      arrhhmm = tNS
      dephhmm = tNS
      trainLength = 600
      priority = 6
      # prefPlatforms = trn.prefPlatforms 
      maxSpeed = trn.maxSpeed
      isPassenger = False
      locoPlan = trn.locoPlan
      NS+=1
      
      
   elif case == 1:
      numb = "new-NSG"+str(NSG+1)
      source = np.random.choice(['S85','S87'])
      destin = '494'
      arrhhmm = tNSG
      dephhmm = tNSG
      trainLength = 600
      priority = 6
      # prefPlatforms = trn.prefPlatforms 
      maxSpeed = trn.maxSpeed
      isPassenger = False
      locoPlan = trn.locoPlan
      # tNSG = m2hm(hhmm2mm(tNSG)+10)
      NSG+=1

   elif case == 2:
      numb = "new-SN"+str(SN+1)
      source = np.random.choice(['283-303','284-307'])
      destin = np.random.choice(['S85','S87'])
      arrhhmm = tSN
      dephhmm = tSN
      trainLength = 600
      priority = 6
      # prefPlatforms = trn.prefPlatforms 
      maxSpeed = trn.maxSpeed
      isPassenger = False
      locoPlan = trn.locoPlan
      # tSN = m2hm(hhmm2mm(tSN)+10)
      SN+=1

   elif case == 3:
      numb = "new-SNG"+str(SNG+1)
      source = '494'
      destin = np.random.choice(['S85','S87'])
      arrhhmm = tSNG
      dephhmm = tSNG
      trainLength = 600
      priority = 6
      # prefPlatforms = trn.prefPlatforms 
      maxSpeed = trn.maxSpeed
      isPassenger = False
      locoPlan = trn.locoPlan
      # tSNG = m2hm(hhmm2mm(tSNG)+10)
      SNG+=1
   temp = Train(numb,source,destin,arrhhmm,dephhmm,
               trainLength,priority,prefPlatforms,maxSpeed,isPassenger,locoPlan)
   
   return temp
   

global eLst
eLst={}  # Edge instantiation
for i in range(len(efName)): # Edge instantiation
  if efName[i].startswith('z'): pass 
  else:
    ename = efName[i]
    temp = Edge(i,efName[i],efLength[i],float(efMaxSpeed[i]))
    if ename in preOccEdName:
      idx = preOccEdName.index(ename) # TODO assuming ATMOST just *one* pre-occupation per edge!!
      if not(str(preOccSrNum[idx]).startswith('z')):
        temp.occupy(preOccReaso[idx], preOccStartMM[idx], preOccEndMM[idx])
        print("Found a preoccupation", i, idx, str(preOccSrNum[idx]), ename, preOccReaso[idx], preOccStartMM[idx], preOccEndMM[idx])
      else: print("Found a preoccupation, but ignoring", i, idx, str(preOccSrNum[idx]), ename, preOccReaso[idx], preOccStartMM[idx], preOccEndMM[idx])
    eLst[temp.name]=temp

nLst=[] # Node instantiation
for i in range(1,len(nf)):
  temp = Node(int(nf.ix[i,0]),nf.ix[i,1],nf.ix[i,4]) # had ef instead of nf.ix[i,2]
  nLst.append(temp)

print('EdgeList and NodeList created')


lfSrNum=lineF['SrNum'].values.tolist()
lfEN=lineF['EdgeName'].values.tolist()
lfEN_NorthSide=lineF['NorthSideProtectionEdge'].values.tolist()
lfEN_SouthSide=lineF['SouthSideProtectionEdge'].values.tolist()
lfLN=lineF['LineNumber'].values.tolist()
lfLOP=lineF['LineOrPlatform'].values.tolist()

# ed = getEdge('444_SH248',eLst,nLst)
# print ed.name, '444_SH248'
# ed = getEdge('439_459',eLst,nLst)
# print ed.name, '439_459'

lineNameEdge = {}
for i in range(len(lfEN)):
 # print "LinePlat", lfEN[i],
 if lfSrNum[i].startswith('z'): 
    # pass # print "Ignoring", lfEN[i]
    print("Ignoring", lfEN[i], lfSrNum[i])
 else:  
    edge = getEdge(lfEN[i],eLst,nLst)
    # print "LinePlat", edge.num, lfEN[i], edge.name, edge.lineNum, lfLN[i], lfLOP[i], lfLOP[i].split("-")[1], lfSrNum[i]
    edge.isLine = True # except for platform, all are lines. Platforms get set next
    if lfLOP[i].startswith('Platfor') or lfLOP[i].startswith('Line'):
       edge.lineNum = lfLOP[i].split("-")[1]
       lineNameEdge[lfLOP[i].split("-")[1]] = edge
    edge.clearanceN = getEdge(lfEN_NorthSide[i],eLst,nLst) # edge.clearanceN is already and edge OBJECT
    edge.clearanceS = getEdge(lfEN_SouthSide[i],eLst,nLst) # edge.clearanceS is already and edge OBJECT
    # print "Appended north/south edges to :", edge.name, edge.clearanceN.name, edge.clearanceS.name

print('Lines and Platforms found')

for hp in halfPathLst:
  hp.setPlatform()
  # print "To check NoSuhPart", hp.isSouth, hp.isNorth

trainList=[] # instantiating Trains Class Train:
for i in range(len(tfSrN)): # all rows (with and without z's)
  if not(str(tfSrN[i]).startswith('z')):
     temp = Train(str(tfNum[i]),tfSou[i],tfDes[i],str(tfArr[i]),str(tfDep[i]),tfLengM[i],tfPri[i],tfPreLin[i], tfMaxSp[i], tfPassYN[i], tfLocoPlan[i])
   #   temp.prefPlatforms = str(temp.prefPlatforms).split(";")
   #   for pl in temp.prefPlatforms:
   #      temp.prefEdges.append(lineNameEdge[pl].name)
   #   getAllPathsFromHalfPaths(temp)
     if temp.isPassenger: 
       tempD1 = copy.deepcopy(temp)
       tempD1.numb+='d1'
       trainList.append(tempD1) # to append or not: just comment here
       tempD2 = copy.deepcopy(temp)
       tempD2.numb+='d2'
       tempD2.arrmm += 1440
       tempD2.depmm += 1440
       trainList.append(tempD2) # to append or not: just comment here
       tempD3 = copy.deepcopy(temp)
       tempD3.numb+='d3'
       tempD3.arrmm += 2880
       tempD3.depmm += 2880       
       trainList.append(tempD3) # to append or not: just comment here
     else: # a freight train: isPassenger is False: so only Day-2
       temp.numb+='d2'
       # temp.arrmm += 1440
       # temp.depmm += 1440
       trainList.append(temp)

if PathViewCheck: # true or false (defined on the top)
  print("ZzZ,NoSuhPart:PathName:LineIndx,SouOrLine,LineOrDes,LineName,Edge1,Edge2,Edge3,etc,etc,,,")
  for tr in trainList:
    for p in tr.allpaths:
     print("ZzZ,", tr.numb, ':'.join(tr.prefEdges), ':'.join(tr.prefPlatforms), tr.source, tr.destin, 'dum3,dum4,,,', ','.join(p) )
     # For Sudarshan/Vipin to extract path by path:
     # Take full output to a full-log-file, (by python file.py > log-file) and then:
     # grep 'ZzZ' log-file | cut -d"," -f2- > desired-file-in-sudarshan-vipin-view-format
     # -Madhu, 24th May 2019

sortedTrainList = sorted(trainList, key=lambda x: (x.priority,x.depmm), reverse=False)

 
for tr in sortedTrainList:
  # print tr.numb, tr.priority, tr.arrhhmm, tr.dephhmm, tr.arrmm, tr.depmm, tr.isPassenger, tr.source, tr.destin
  if checkPathLengths:
    for indx,path in enumerate(tr.allpaths):
       print("GetPathLengths: source, platform, destination, length(m)", tr.source, tr.prefEdges, tr.prefPlatforms, tr.destin, sum(tr.allpathsLengthTups[indx]))

# exit()

def checkEntr2Platform(tr, maxSpeedVal, pathIndx, actArrTime, actDepTime):
   j = pathIndx
   i = tr.plIndx[j]
   gotWithinThrsld = True
   tr.entryInJunctionAreaList.append(None)
   while i >= 0: # check BACKWARDS starting from platform index in the path
       # if DEBUG: print "DEBUG", m2hm(actArrTime)

       e = getEdge(trpath[i],eLst,nLst)  # e can be edge OR NODE!!
       if isPathEdgeLine(trpath[i],eLst):#checks whether the edge in path is Platform/Line
         if tr.isThrough: # no reduced speed on platform/line
            junctionEntrTime = actArrTime - l2m(tr.allpathsLengthTups[j][0],maxSpeedVal,0)
            # junctionExitTime = actDepTime + l2m(tr.allpathsLengthTups[j][1],maxSpeedVal,0)
            platformEntrTime=actArrTime-l2m(e.length,maxSpeedVal,0) # Madhu # head has to reach exit : no averaging for through trains
            platformExitTime=actDepTime+l2m(0,maxSpeedVal,tr.trainLength) # Madhu # tail has to pass starter : no averaging for through trains
         else:
            # print("Error5:", tr.allpaths[j][tr.plIndx[j]])
            junctionEntrTime = actArrTime - (l2m(tr.allpathsLengthTups[j][0]-getEdge(tr.allpaths[j][tr.plIndx[j]],eLst,nLst).length,maxSpeedVal,0)+l2m(getEdge(tr.allpaths[j][tr.plIndx[j]],eLst,nLst).length,maxSpeedVal/2,0))
            platformEntrTime=actArrTime-l2m(e.length,maxSpeedVal/2,0) # Madhu # head has to reach exit (and averaged:/2)
            platformExitTime=actDepTime+l2m(0,maxSpeedVal/2,tr.trainLength) # Madhu # tail has to pass starter (and averaged:/2)
            # platformEntrTime = t1 # Head Entry into platform
            # platformExitTime = t2 # Tail Exit from platform
         tHeCrEntr = platformEntrTime
         tTaCrExit = platformExitTime
         eNPlatFree = e.isFree(junctionEntrTime,tTaCrExit)
         if actArrTime > tr.arrmm + thresholdMinsLine:
            gotWithinThrsld = False
            print("Platform/Line not free for", e.name, tr.numb, "inspite of", thresholdMinsLine, "mins delay: so giving up this platform")
            return False, actArrTime, actDepTime, platformEntrTime, gotWithinThrsld
       else: # edge is not platform but just a regular edge
         tHeCrEntr += -l2m(e.length,maxSpeedVal,0)   
         tTaCrExit = tHeCrEntr + l2m(e.length,maxSpeedVal,tr.trainLength)   
         # t1 = tHeCrEntr
         # t2 = tTaCrExit
         eNPlatFree = e.isFree(junctionEntrTime,tTaCrExit) # and getEdge(trpath[tr.plIndx[j]],eLst,nLst).isFree(tHeCrEntr,tTaCrExit) # Put # before and check output same or not : TODO
         if actArrTime > tr.arrmm + thresholdMinsPath: # Entering too late...
            gotWithinThrsld = False
            # print("Entire path not free for train (due to edge)", e.name, tr.numb, "inspite of", thresholdMinsPath, "mins delay")
            return False, actArrTime, actDepTime, platformEntrTime, gotWithinThrsld
       if eNPlatFree: # THAT edge is not occupied, then check for next edge 
          tr.entryInJunctionAreaList[-1]=tHeCrEntr # i == 0 means beginning of path, at SOURCE (Enters junction area)
          i += -1 # resume while-loop (for THAT path)
       else: # some edge is already occupied in THAT path, try after sometime again.
          actArrTime += fineness # i.e. arrival time gets (further) incremented
          actDepTime += fineness # i.e. departure time gets (further) incremented
          i = tr.plIndx[j] 
          if analyzeCongestion: print("Congestion detected in edge/train: increasing actArrTime by:", tr.numb, e.name, actArrTime-tr.arrmm)
          # t1, t2 = 0, 0
   
   return True, actArrTime, actDepTime, platformEntrTime, gotWithinThrsld
   # FoundEntr, actArrTime, actDepTime, platformEntrTime, gotWithinThrsld
   # finished CHECKING for ENTERING

def checkPlatform2Exit(tr, actArrTime, actDepTime, pathIndx, maxSpeedVal): 
   i = tr.plIndx[j] # Checking from platform onwards FRONT (exit side)
   # t1, t2 = 0, 0
   # maxSpeedVal = maxSpeed(trpath[i:],eLst, nLst) # TODO: ensure for through trains, FULL path maxSpeed to BEGIN with
   while i < len(trpath): # check FORWARDS starting platform index in the path AND towards exit/destin
      e = getEdge(trpath[i],eLst,nLst) 
      if isPathEdgeLine(trpath[i],eLst): #checks whether the edge in path is platform # checking happens at both times!! forward and backward, and no harm it appears. 
        if tr.isThrough: # no reduced speed on platform/line
           junctionEntrTime = actArrTime - l2m(tr.allpathsLengthTups[j][0],maxSpeedVal,0)
           tHeCrEntr=actArrTime-l2m(e.length,maxSpeedVal,0) # Madhu divided speed by 2 & zeroed train-length contri 
           platformExitTime=actDepTime+l2m(0,maxSpeedVal,tr.trainLength) # Madhu divided speed by 2 & zeroed edge contri
        else:
           tHeCrEntr=actArrTime-l2m(e.length,maxSpeedVal/2,0) # Madhu divided speed by 2 & zeroed train-length contri 
           platformExitTime=actDepTime+l2m(0,maxSpeedVal/2,tr.trainLength) # Madhu divided speed by 2 & zeroed edge contri
        tHeNxEntr = actDepTime 
        tTaCrExit = platformExitTime
      else:
        tTaCrExit = tHeNxEntr + l2m(e.length, maxSpeedVal, tr.trainLength) 
        tHeCrEntr = tHeNxEntr # current edge head entry # relevant for occupancy check
        tHeNxEntr = tHeNxEntr + l2m(e.length, maxSpeedVal, 0) # Madhu
      # if e.isFree(tHeCrEntr,tTaCrExit): # THAT edge is not occupied, then check for next edge
      if tr.isThrough: edgeFreeFlag = e.isFree(junctionEntrTime,tTaCrExit)
      else: edgeFreeFlag = e.isFree(actDepTime,tTaCrExit)
      
      if edgeFreeFlag: # THAT edge is not occupied, then check for next edge
         i += 1
         if i == len(trpath): 
             tr.exitFromJunctionAreaList.append(tTaCrExit)
             yet2FindPath = False # i.e. FOUND exit path from the junction area, and can come out of overall while loop
         junctionExitTime = tTaCrExit # occupy till exit time (safety) # 
      else: # some edge is already occupied, try after sometime again.
         actArrTime += fineness
         actDepTime += fineness
         i = tr.plIndx[j]
         # t1, t2 = 0, 0
     # go back to while-loop to EXIT (i.e. i < len(trpath) while loop starts)
   gotWithinThrsld = True
   return True, actArrTime, actDepTime, junctionExitTime, platformExitTime, yet2FindPath, gotWithinThrsld
        #  FoundExit, actArrTime, actDepTime, junctionExitTime, platformExitTime, yet2FindPath, gotWithinThrsld = checkPlatform2Exit(tr, actArrTime, actDepTime, j)
   # finished CHECKING for EXITting

def occupyEntr2Platform(tr, maxSpeedVal, path2occupy, bestPathIndx, platformEntrTime, platformExitTime):
   j = bestPathIndx
   for eName in path2occupy: # occupy platform backwards (except platform: which is in forward direction)
     e = getEdge(eName,eLst,nLst)
     if isPathEdgeLine(e.name,eLst):#checks whether the edge in path is platform
       if tr.isThrough:
          tHeCrEntr = tr.actArrTimeList[j] - l2m(e.length,maxSpeedVal,0) # Actual arrival - time to enter: head enters platform edge at t1
          tTaCrExit = tr.actDepTimeList[j] + l2m(0,maxSpeedVal,tr.trainLength) # Actual departure + time for tail to vacate
       else:
          tHeCrEntr = tr.actArrTimeList[j] - l2m(e.length,maxSpeedVal,0) # Actual arrival - time to enter: head enters platform edge at t1
          tTaCrExit = tr.actDepTimeList[j] + l2m(0,maxSpeedVal,tr.trainLength) # Actual departure + time for tail to vacate
       e.occupy(tr.numb,tr.entryInJunctionArea,tTaCrExit) # # platform gets occupied in backward # RLSR
       # e.occupy(tr.numb,tHeCrEntr,tTaCrExit) # # platform gets occupied in backward # SLSR
       # print("Err44: e10.5",  tr.arrmm, tr.depmm, tr.actArrTimeList[j], tr.actDepTimeList[j])
     else:
       dum = tHeCrEntr
       tHeCrEntr = tHeCrEntr - l2m(e.length,maxSpeedVal,0) # RHS tHeCrEntr is FOLLOWING edge's Head entry 
       # LHS tHeCrEntr is CURRENT edge's Head entry 
       tTaCrExit = tHeCrEntr + l2m(e.length,maxSpeedVal,tr.trainLength) # Tail exits current edge
       e.occupy(tr.numb, tr.entryInJunctionArea, tTaCrExit) # route-lock-section-release (RLSR)
       # e.occupy(tr.numb, tHeCrEntr, tTaCrExit) # section-lock-section-release (SLSR)
       # print "Err44:", e.name, tr.arrmm, tr.depmm, tr.actArrTimeList[j], tr.actDepTimeList[j], tHeCrEntr, dum, tTaCrExit
   return True
   # finished OCCUPYING for ENTERING

def occupyPlatform2Exit(tr, maxSpeedVal, path2occupy, bestPathIndx, actDepTime, junctionExitTime):
   j = bestPathIndx
   for eName in path2occupy: 
     # print eName,
     e = getEdge(eName,eLst,nLst)
     if isPathEdgeLine(eName,eLst): # Platform ALREADY occupied during junction entry
       tHeNxEntr = tr.actDepTimeList[j] # time at which Train's Head enters NEXT edge
     else: 
       tTaCrExit = tHeNxEntr + l2m(e.length, maxSpeedVal, tr.trainLength) # Madhu
       # tTaCrExit: time at which TAIL of train Exits CURRENT edge: affects occupancy # Madhu
       # e.occupy(tr.numb, tHeNxEntr, tTaCrExit) # section lock section release # SLSR Madhu
       if tr.isThrough: e.occupy(tr.numb, tr.entryInJunctionArea, tTaCrExit)
       else: e.occupy(tr.numb, actDepTime, tTaCrExit) # route lock section release # RLSR Madhu 
       
       dum = tHeNxEntr
       tHeNxEntr += l2m(e.length, maxSpeedVal, 0) # entry of Head into NEXT edge decided only by current edge's length # Madhu
       # print "Err44:", e.name, tr.arrmm, tr.depmm, tr.actArrTimeList[j], tr.actDepTimeList[j], dum, tHeNxEntry, tTaCrExit
       # t1 = t2 # Sudhanshu
       # t2 = t2+l2m(e.length,maxSpeedVal,tr.trainLength) # Sudhanshu
       # e.occupy(tr.numb, t1, junctionExitTime) # route lock section release# Sudhanshu
       # print "OccupiED edge/node Forwards:", tr.numb, m2hm(t1), m2hm(junctionExitTime), e.name
   return True
   # finished OCCUPYING for EXITting

print("Train-Stats","Train-number", "Actual Arrival", "Actual Departure", "Entry-in-junctionArea", "Exit-from-junctionArea", "Difference")

# print("sudarshan",'allpaths','plIndx','entryInJunctionAreaList','exitFromJunctionAreaList','costPath','actArrTimeList','actDepTimeList','allpathsMaxSpeeds','allpathsLengthTups')
# exit()


if findFrCapacity: frTrain=[i for i in sortedTrainList if i.isPassenger == False][0]
# consistently: j for index of current path (which is being considered), and i for index of edge IN the j'th PATH
count = 0
capacityYet2Reach = True
addedFreights=[]
while capacityYet2Reach:
   if count < len(sortedTrainList):
      tr = sortedTrainList[count]
   elif findFrCapacity: # need to find capacity
      tr = addFreightTrain(frTrain,count%4)
      addedFreights.append(tr)
   else: break # to break out of while loop (no freight trains are created)
   count+=1
   frTrain = tr
   # actArrTime, actDepTime, j = tr.arrmm, tr.depmm, 0 # can initialize only j=0 and remove others
   j = 0
   while j<len(tr.allpaths): #in case of multiple path possible 
       trpath = tr.allpaths[j]
       for i in range(0,len(trpath)): # in principle can be pushed into Train class as a method
          if isPathEdgeLine(trpath[i],eLst): 
             tr.plIndx.append(i) # 
             break # breaks out of for loop (found the line location)
       
       actArrTime, actDepTime = tr.arrmm, tr.depmm
       yet2FindPath = True
       # while yet2FindPath:
       # t1, t2 = 0, 0
       i = tr.plIndx[j]
       # print "yet2FindPath", yet2FindPath, tr.numb, "path-index", j
       if tr.isThrough: # also check that departure = arrival, speeds should not be halved
         actArrTimeEntr = tr.arrmm # ideally two should equal
         actArrTimeExit = tr.arrmm + 0.2
         actDepTime = tr.depmm
         while abs(actArrTimeExit - actArrTimeEntr) > 0.1:
             maxSpeedVal = min(tr.maxSpeed,maxSpeed(trpath[0:i+1],eLst, nLst))
             FoundEntr, actArrTime, actDepTime, platformEntrTime, gotWithinThrsld = checkEntr2Platform(tr, maxSpeedVal, j, actArrTimeEntr, actDepTime) 
             actArrTimeEntr = actArrTime
             i = tr.plIndx[j] # Checking from platform onwards FRONT (exit side)
             maxSpeedVal = min(tr.maxSpeed, maxSpeed(trpath[i:],eLst, nLst)) # TODO: ensure for through trains, FULL path maxSpeed to BEGIN with
             FoundExit, actArrTime, actDepTime, junctionExitTime, platformExitTime, yet2FindPath, gotWithinThrsld = checkPlatform2Exit(tr, actArrTime, actDepTime, j, maxSpeedVal)
             actArrTimeExit = actArrTime
             if abs(actArrTimeExit - actArrTimeEntr) > 0.1:
                  print("Through: Delaying ENTRY (due to exit difficulties inspite of early entry) for through train", tr.numb, tr.arrmm, actArrTimeEntr, actArrTimeExit)
             else:
                  print("Through: Entry good enough to exit immediately for through train", tr.numb, tr.arrmm, actArrTimeEntr, actArrTimeExit)
       else: # non-through trains wait at platform (indefinitely) till exit route is found
          maxSpeedVal = min(tr.maxSpeed, maxSpeed(trpath[i:],eLst, nLst)) # TODO: ensure for through trains, FULL path maxSpeed to BEGIN with
          FoundEntr, actArrTime, actDepTime, platformEntrTime, gotWithinThrsld = checkEntr2Platform(tr, maxSpeedVal, j, tr.arrmm, tr.depmm) 
          i = tr.plIndx[j] # Checking from platform onwards FRONT (exit side)
          # t1, t2 = 0, 0
          maxSpeedVal = min(tr.maxSpeed, maxSpeed(trpath[i:],eLst, nLst)) # TODO: ensure for through trains, FULL path maxSpeed to BEGIN with
          FoundExit, actArrTime, actDepTime, junctionExitTime, platformExitTime, yet2FindPath, gotWithinThrsld = checkPlatform2Exit(tr, actArrTime, actDepTime, j, maxSpeedVal)
          # print "for yet2FindPath (train numb, path index)", tr.numb, j, FoundExit, actArrTime, actDepTime, junctionExitTime, platformExitTime, yet2FindPath, gotWithinThrsld
  
       totalCost=(actArrTime-tr.arrmm) ##Scheduled time = tr.arrmm .... 
       # actArrTime: ACTUAL time of Head reaching platform's exit-end. 
       # (ideally: if without congestion: totalCost = 0)
       tr.costPath.append(totalCost) #append the cost of every path 
       tr.pathFree.append(FoundEntr and FoundExit)
       tr.actArrTimeList.append(actArrTime)     
       tr.actDepTimeList.append(actDepTime) 
       if totalCost==0: 
          print("Breaking out of while loop since found a path of cost (delay) zero", tr.numb, actArrTime)
          break # breaks out of search for best path (while loop)
       else: j += 1 # go for next path for same train  (j was path index for that train)


   # End of while j < len(tr.allpaths) loop
   if len(tr.costPath)==0: print("Error: had no path for train/source/destin/platf:", tr.numb, tr.source, tr.destin, tr.actDepTime,tr.depmm, tr.prefEdges)
   else: print("Found at least one path for train/source/destin/platf/bestCost/index:", tr.numb, tr.source, tr.destin, tr.actDepTime,tr.depmm, tr.prefEdges, tr.costPath[0], tr.costPath.index(min(tr.costPath)))
   minCost = [tr.costPath[i] for i in range(len(tr.costPath)) if tr.pathFree[i]]
   print("sudarshan",len(tr.allpaths),len(tr.plIndx),len(tr.entryInJunctionAreaList),len(tr.exitFromJunctionAreaList),len(tr.costPath),len(tr.actArrTimeList),len(tr.actDepTimeList),len(tr.allpathsMaxSpeeds),len(tr.allpathsLengthTups))
   
   if minCost==[]: 
      print("Train-Stats", tr.numb, "Found no path on this day")
      if "new" in tr.numb: addedFreights = addedFreights[:-1]
      continue

   j=tr.costPath.index(min(minCost)) # take the index of least-delay path and use it for occupying the edges. 
   
   trpath = tr.allpaths[j]
   tr.selectedPath = trpath 
   tr.trainOccupied = True
   tr.actDepTime=tr.actDepTimeList[j]
   tr.actArrTime=tr.actArrTimeList[j]
   tr.exitFromJunctionArea=tr.exitFromJunctionAreaList[j]  
   tr.entryInJunctionArea=tr.entryInJunctionAreaList[j]
   selectedLine=trpath[tr.plIndx[j]]
   # print "Error5: (almost, but not yet) train, j, selLine:", tr.numb, j, selectedLine
   # print "Error3: (almost, but not yet) tr-allpaths-j, tr-plIndx-j", tr.allpaths[j], tr.plIndx[j]
   # print "Error3: (almost, but not yet) trpath", trpath # trpath and tr.allpaths[j] are not the same!!!
   tr.selectedLine=returnPathEdgeLineNum(selectedLine, eLst)
   # Now start OCCUPYING along the best path!! 
   path2occupy = tr.allpaths[j][:tr.plIndx[j]+1]
   path2occupy.reverse() 
   # print "Checking5:", tr.numb, maxSpeedVal, path2occupy, j, platformEntrTime, platformExitTime
   occupiedTF = occupyEntr2Platform(tr, maxSpeedVal, path2occupy, j, platformEntrTime, platformExitTime)# PLAtform to get occupied during ENTRY
   path2occupy = tr.allpaths[j][tr.plIndx[j]:]
   # print "Checking6:", tr.numb, maxSpeedVal, path2occupy, j, platformEntrTime, platformExitTime
   occupiedTF = occupyPlatform2Exit(tr, maxSpeedVal, path2occupy, j, tr.actDepTime, junctionExitTime)
   if tr.actDepTime > 2880 and not(tr.isPassenger): # and findFrCapacity
      capacityYet2Reach = False # capacity reached
   

#constructing occupancy chart
allEdgeOcc={}
for ed in eLst.values():
   allEdgeOcc[ed.name]={}
   for tr in ed.occupancy:
      allEdgeOcc[ed.name][tr[0]]=tr[1:]

for tr in sortedTrainList + addedFreights:
    print("Train-Stats", tr.numb, tr.actArrTime, tr.actDepTime, tr.entryInJunctionArea, tr.exitFromJunctionArea, tr.exitFromJunctionArea- tr.entryInJunctionArea)
print("Train-Stats","Train-number", "Actual Arrival", "Actual Departure", "Entry-in-junctionArea", "Exit-from-junctionArea", "Difference")
print("Train-Stats:Passenger",len(sortedTrainList))
print("Train-Stats:Freights",len(addedFreights))

# reqEdges=[tr.selectedPath for tr in trainList if '19217' in tr.numb][0]
# occupancyOfEds=[getEdge(i,eLst,nLst).occupancy[0][1:] if '19217' in getEdge(i,eLst,nLst).occupancy[0][0] else getEdge(i,eLst,nLst).occupancy[1][1:] for i in reqEdges]
# for i,time in enumerate(occupancyOfEds):
     # plt.plot((i,i),(time[0],time[1]),'r')
# plt.show()




if printOccupancyLists:
  for e in eLst.values():
    if len(e.occupancy) > 0: print("OCCupied", e.name, e.occupancyHHMM)
  for n in nLst:
    if len(n.occupancy) > 0: print("OCCupied", n.name, n.occupancyHHMM)

# this is calculating which train is using which platform
v = []
u = []
for h in eLst.keys():
    if eLst[h].isLine:
        s = 0
        # print(eLst[h].__dict__)
        for r in range (len(eLst[h].occupancy)):
            s = s + eLst[h].occupancy[r][2] - eLst[h].occupancy[r][1]
        v.append(s/3600)
        u.append(eLst[h].name)    
        # print()

x = []
y = []
for p in eLst.keys():
    if eLst[p].isLine:
        s = 0
        for r in range (len(eLst[p].occupancy)):
            s = s + eLst[p].occupancy[r][2] - eLst[p].occupancy[r][1]
        if s > 0.0001:
          y.append(s/3600)
          x.append(eLst[p].name)    

#for display of edges occupied
maxEdgesinGivenMin=max([len(i) for i in _EdgeOccupancyinMin.values()])
fileKeys=['NoSuhPart:PathName:LineIndx','SouOrLine','LineOrDes','LineName']
fileKeys+=['Edge'+str(i+1) for i in range(maxEdgesinGivenMin)]
displayOccEdgesdict={i:[] for i in fileKeys}
 
if toVisualize:
 for minute,occEdges in _EdgeOccupancyinMin.items():
  displayOccEdgesdict['NoSuhPart:PathName:LineIndx'].append(str(minute)+'mins')
  displayOccEdgesdict['SouOrLine'].append('dumm')
  displayOccEdgesdict['LineOrDes'].append('dumm')
  displayOccEdgesdict['LineName'].append('dumm')
  occEdges=iter(occEdges)
  for i in range(maxEdgesinGivenMin):
    p = str(next(occEdges,None))
    if i==0 and p == 'None':
      displayOccEdgesdict['NoSuhPart:PathName:LineIndx'][-1]='z'+displayOccEdgesdict['NoSuhPart:PathName:LineIndx'][-1]
    displayOccEdgesdict['Edge'+str(i+1)].append(str(p))

 displayDf=pd.DataFrame(displayOccEdgesdict)
 displayDf.to_csv('occupancyInMinutes.csv',index=False,columns=fileKeys)
 print('Visualization csv output Generated') 


exit()

plt.gca().tick_params(axis='x', pad= 3)
width = 1/1.8
plt.xticks(rotation="vertical")
plt.bar(x, y, width,color="blue")

plt.title('occupancy of platform')
plt.xlabel('platform/line name')
plt.ylabel('hours')

fig = plt.gcf()
plt.savefig("generated-figures/fig_2.png", bbox_inches='tight')
plt.savefig("generated-figures/fig_2.pdf", bbox_inches='tight')


x = []
y = []
for p in range(len(eLst)):
    if not(eLst[p].isLine):
        s = 0
        for r in range(len(eLst[p].occupancy)):
            s = s + eLst[p].occupancy[r][2] - eLst[p].occupancy[r][1]
        if s > 0.00001: # only for occupied edges
           y.append(s/3600.0)
           x.append(eLst[p].name)    
   
plt.gca().tick_params(axis='x', pad= 3)
width = 1/1.8
plt.xticks(rotation="vertical")
plt.bar(x, y, width,color="blue")

plt.title('occupancy of edges')
plt.xlabel('platform/line name')
plt.ylabel('hours')

fig = plt.gcf()

plt.savefig("generated-figures/fig_3.png", bbox_inches='tight')
plt.savefig("generated-figures/fig_3.pdf", bbox_inches='tight')


displayedge=[]
for i in range(len(eLst)):
    displayedge.append([eLst[i].num,eLst[i].name,0])
    for j in eLst[i].occupancy:
        displayedge[i][2]+=j[2]-j[1]
temp1=[i[2] for i in displayedge]  

temp=[]
for i in displayedge:
    temp.append(i[2])


eLst[2].occupancy
#edge occupancy  
for e in eLst:
   for i in range(len(e.occupancy)):
       for j in range(1,len(e.occupancy[i])):         
           e.occupancy[i][j]=e.occupancy[i][j]/60.0




exit()

"""
full path min speed to begin with : for through trains
full path availability (upto exit) checked before entry allowed into junction area
Speed on each edge: minimum of entry-platform, or platform to exit, or full path (depending on through or not)
   Check maxSpeed for FULL path for through trains
priority wise scheduling
line/platform check
hhmm to mm to hhmm check
clog network and check if getting no path found: overcongested/jammed)
"""

# Why negative numbers get returned and causes hyphen (-) in hhmm

# Things to do for Sudarshan (in any order).
# compare with logf.log file using python file.py  | diff - old-logFile.log

# 7. Sort is first based on priority, and then based on departure time. (DONE)
# 5. For all freight trains, make the arr/dep time as same-time + 1440 (when instantiating the train) (DONE)
# 5A. For all freight trains,  append D2 in their train-number (DONE)
# 6. For all non-freight trains, make arr-time/dep-time as same-time, same-time + 1440 + same-time 2880 (DONE)
# 6A. Change all train-numbers to string: and append D1, D2, D3 (day1, Day2, Day3) (currently train.numb is integer)(DONE)
# 8. Check that if train arrives late, then dep-arrival is same as original one.


# 2. for halfpaths, make new attributes: north-side/south-side terminals of the platform
# 3. for every train, initiate new loco that has perhaps lower priority and
#    goes from north-side or south-side of platform to Diesel-loco-shed.

# 9. If it is a through train (like freight), check that Madhu has finished making it
#    lock-route not just till platform, but till junction exit link.

# 10. if time is negative, then hhmm, etc don't work

def seekLoco(forTrainNum,sour,dest,arrhhmm,dephhmm):
   """ Will eventually create a loco only if all are busy now. For now, just
   instantiate a new loco whenever needed."""
   temp = Train('DLoco',sour,dest,arrhhmm,dephhmm,'',0,1,sour,0,False)
   getAllPaths(temp)
   print("Before creating", len(trainList))
   temp.actArrTimeList=[0]
   temp.actDepTimeList=[0]
   trainList.append(temp)
   return temp


